/*************************************************************************************
    Semantic check about HPF distribute and align directive
    written by Wang Zhenlin
**************************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include <stdio.h>

#   include "typedef.h"
#   include "bif.h"
#   include "ll.h"
#   include "symb.h"

#include "defnodes.h"
#include "tags.h"
#include "decl.h"
 
#include "exglobal.h"

/* check processors statement */
int processors_decl_stmtc(cur_bfnd)
PTR_BFND cur_bfnd;
{
	PTR_LLND expr_list,ele,range;
	PTR_SYMB sym;

	for (expr_list=cur_bfnd->entry.Template.ll_ptr1;expr_list;
		expr_list=expr_list->entry.Template.ll_ptr2 )
	{
		ele=expr_list->entry.Template.ll_ptr1;
		sym=ele->entry.Template.symbol;
		range=ele->entry.Template.ll_ptr1;
		/* check range if present in dimension */
                check_array_range(range);
		sym->decl=HARD;
	}
}

/*check distribute statement*/
int distribute_decl_smtc(cur_bfnd)
PTR_BFND cur_bfnd;
{
   distribute_attr_smtc(cur_bfnd->entry.Template.ll_ptr1,cur_bfnd->entry.Template.ll_ptr3->entry.Template.ll_ptr1,1); 
/*see distribute.c*/
}

/*check redistribute statement*/
int redistribute_stmt_smtc(cur_bfnd)
PTR_BFND cur_bfnd;
{
   distribute_attr_smtc(cur_bfnd->entry.Template.ll_ptr1,cur_bfnd->entry.Template.ll_ptr2,0); /*see distribute.c*/
}

/*check align statement*/
int align_decl_smtc(cur_bfnd)
PTR_BFND cur_bfnd;
{
				/*    1                  2: ALIGN_OP */
   align_attr_smtc(cur_bfnd->entry.Template.ll_ptr1,cur_bfnd->entry.Template.ll_ptr3->entry.Template.ll_ptr1,1); /*see align.c*/
}

/*check realign statement*/
int realign_stmt_smtc(cur_bfnd)
PTR_BFND cur_bfnd;
{
   align_attr_smtc(cur_bfnd->entry.Template.ll_ptr1,cur_bfnd->entry.Template.ll_ptr2,0); /*see align.c*/
}

/*check combined_directive statement*/
int combined_directive_decl_smtc(cur_bfnd)
PTR_BFND cur_bfnd;
{
   PTR_LLND  attr_list,attr,var_list,var_ele;
   PTR_SYMB  sym;
   
   var_list = cur_bfnd->entry.Template.ll_ptr1;
					/* attr_list ->  EXPR_LIST */
   attr_list = cur_bfnd->entry.Template.ll_ptr3;
   while (attr_list != LLNULL){
      attr = attr_list->entry.Template.ll_ptr1;
      switch (attr->variant) {
					/* modified by zheng.gb & HIT */
          case DISTRIBUTE_ATT:
                  distribute_attr_smtc(cur_bfnd->entry.Template.ll_ptr1,
					attr->entry.Template.ll_ptr1,1);       
                  break; 
					/* modified by zheng.gb & HIT */
          case ALIGN_ATT:
				/* by zheng.gb ???? miss a argument */
                  align_attr_smtc(cur_bfnd->entry.Template.ll_ptr1,
					attr->entry.Template.ll_ptr1,1);       
                  break;
          case INHERIT_OP:
                  inherit_attr_smtc(cur_bfnd->entry.Template.ll_ptr1);
                  break;
          case DYNAMIC_OP:
   		  /* added by LY, check for PURE function */
   		  if (is_in_pure())
			error3(321);
                  break;
      }
      attr_list = attr_list->entry.Template.ll_ptr2;
   }

   for ( ; var_list ; var_list=var_list->entry.Template.ll_ptr2) {
	var_ele=var_list->entry.Template.ll_ptr1;
	sym=get_var_name(var_ele);
	if (sym) sym->decl=HARD;
   }
}

int inherit_decl_smtc(cur_bfnd)
PTR_BFND cur_bfnd;
{
   inherit_attr_smtc(cur_bfnd->entry.Template.ll_ptr1);
}

int dynamic_decl_smtc(cur_bfnd)
PTR_BFND cur_bfnd;
{
   /* added by LY, check for PURE function */
   if (is_in_pure())
	error3(321);
   return 1;
}

/*variable which has INHERIT attribute should be dummy argument*/
int inherit_attr_smtc(var_list)
PTR_LLND var_list;
{
   PTR_SYMB var;

   while (var_list != LLNULL) {
					/* add by zheng.gb */
       check_leaf_sym(var_list);
       var = var_list->entry.Template.ll_ptr1->entry.Template.symbol;
       if (   var->entry.var_decl.local != IO 
           && var->entry.var_decl.local != INPUT
           && var->entry.var_decl.local != OUTPUT)
           error3(308,var->ident);
       if (have_attribute(var,ALIGN_BIT))
           error3(309,var->ident);
       var_list = var_list->entry.Template.ll_ptr2;
   } 
   /* added by LY, check for PURE function */
   if (is_in_pure())
	error3(320);
}

int isSubobject(symbol)
PTR_SYMB symbol;
{
   return 0;
}

int have_attribute(symbol,attr) 
PTR_SYMB symbol;
int attr;
{
   if (symbol->attr & attr)
      return 1;
   else
      return 0;
}

